global pcmesh_importer,f,s,g,mscale = (1.0 / 2.54) * 100
clearlistener()

singleMesh = false
animLoop = true
animPlay = false
clearScene = true

struct _geometry (
	position=#(),
	texture=#(),
	tface=#(),
	face=#(),
	boneid=#(),
	weight=#(),
	skeleton=#()
	)
struct _file (
	filename=#(),
	size=#()
	)
fn RH2LH corrd = (
	global mscale
	return ([corrd.x,-corrd.z,corrd.y]*mscale)
	)
fn ReadFixedString bstream fixedLen = (
	local str = ""
	for i = 1 to fixedLen do (
		str += bit.intAsChar (ReadByte bstream #unsigned)
		)
	str
	)
fn readstringfixed bstream len = (
	local i=1,str="",b=0
	while i<len do (
		b = readbyte bstream #unsigned
		if b!=0 then (
			str += bit.intaschar b
			)
		else (
			i+=len
			)
		i+=1
		)
	fseek bstream (len-(str.count+1)) #seek_cur
	return str
	)
fn uppercase instring = (
	local upper, lower, outstring
	upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	lower="abcdefghijklmnopqrstuvwxyz"
	outstring=copy instring
	for i=1 to outstring.count do (
		j=findString lower outstring[i]
		if (j != undefined) do outstring[i]=upper[j]
		)
	outstring
	)
fn triangle_strip count = (
	global f,g
	local fa,fb,fc,x,y
	local face_flip = true
	local face_reset=true
	local face_add = 1
	x=1;while x<= count do (
		x+=1
		if face_reset == true then (
			x+=2;face_reset=false;face_flip = false
			fa = (readshort f #unsigned) + face_add
			tfa = (readshort f #unsigned) + face_add
			fb = (readshort f #unsigned) + face_add
			tfb = (readshort f #unsigned) + face_add
			fc = (readshort f #unsigned) + face_add
			tfc = (readshort f #unsigned) + face_add
			if face_flip == true then (
				append g.face [fa,fc,fb];face_flip=false
				append g.tface [tfa,tfc,tfb];face_flip=false
				)
			else(
				append g.face [fa,fb,fc];face_flip=true
				append g.tface [tfa,tfb,tfc];face_flip=true
				)
			)
		else(
			fa = fb
			fb = fc
			fc = readshort f #unsigned
			tfa = tfb
			tfb = tfc
			tfc = readshort f #unsigned
		if fc!=0xFFFF and tfc!=0xFFFF then (
			fc += face_add
			tfc += face_add
			if face_flip == true then (
					append g.face [fa,fc,fb];face_flip=false
					append g.tface [tfa,tfc,tfb];face_flip=false
					)
				else(
					append g.face [fa,fb,fc];face_flip=true
					append g.tface [tfa,tfb,tfc];face_flip=true
					)
				)
			else(
				face_reset=true
				)
			)
		)
	)
fn triangle_list count = (
	global f,g
	local fa,fb,fc,x,y
	local face_add = 1
	for x = 1 to count/4 do (
		fa = (readshort f #unsigned)+face_add
		fa2 = (readshort f #unsigned)+face_add
		fb = (readshort f #unsigned)+face_add
		fb2 = (readshort f #unsigned)+face_add
		fc = (readshort f #unsigned)+face_add
		fc2 = (readshort f #unsigned)+face_add
		append g.face [fa,fb,fc]
		)
	)
fn buildskin msh = (
	global g
	local i,j,d,skinmod,tmp=#()
	if g.skeleton.count!=0 do (
		skinMod = Skin ()
		addmodifier msh skinMod
		max modify mode
		modPanel.setCurrentObject skinMod
		skinMod.bone_Limit = 4
		count = msh.numverts
		for i = 1 to g.skeleton.count do (
			skinOps.addBone skinMod g.skeleton[i] 0
			)
		d = dummy ()
		skinOps.addBone skinMod d 1	--skinOps.addBone skinMod g.skeleton[(g.skeleton.count)] 1
		d.name = "dummy bone" -- work around, assign all weights a value of 1.0 to the dummy bone
		select msh
		modPanel.setCurrentObject skinMod
		skinOps.SelectVertices skinMod #{1..(count)}
		skinOps.selectBone skinMod (g.skeleton.count+1)
		skinOps.SetWeight skinMod 1.0
		skinOps.RemoveZeroWeights skinMod
		select msh
		modPanel.setCurrentObject skinMod
		for i = 1 to count do (
			skinOps.ReplaceVertexWeights skinMod i g.boneid[i] g.weight[i]
			)
		select msh
		modPanel.setCurrentObject skinMod
		skinOps.SelectVertices skinMod #{1..(count)}
		skinOps.selectBone skinMod (g.skeleton.count+1)
		skinOps.SetWeight skinMod 0.0
		skinOps.RemoveZeroWeights skinMod
		delete d
		skinMod.filter_vertices = on
		skinOps.WeightTool skinMod
		)
	)
fn buildObj = (
	global g
	local j,mat
	if g.position.count>0 then (
		msh = mesh vertices:g.position tverts:g.texture faces:g.face --materialIDs:g.matid 
		msh.numTVerts = g.texture.count
		msh.displayByLayer = false
		msh.backfacecull = on
		buildTVFaces msh
		for j = 1 to g.texture.count do setTVert msh j g.texture[j]
		for j = 1 to g.tface.count do setTVFace msh j g.tface[j]
		)
	else(
		print "nothing built"
		)
	buildskin(msh)
	msh
	)
try(destroydialog pcmesh_importer)catch()
rollout pcmesh_importer "PC MESH Importer" (
	group "Import" (
		label lbl1 ""
		button btn1 "IMPORT" width:98 height:34 align:#center
		label lbl2 ""
		spinner spn1 "Scale" range:[-10000,10000,mscale] type:#float
		)
	group "About" (
		label lb3 "Written By:" align:#left
		label lb4 "    Mario_Kart64n" align:#left
		hyperLink lb5 "    mariokart64n@gmail.com" address:"mailto:mariokart64n@gmail.com"
		)
	group "Donate" (
		hyperLink lb7 "       Paypal" address:"https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=coreynguyen%40gmail%2ecom&item_name=maxscript%20work&no_shipping=0&no_note=1&tax=0&currency_code=CAD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8"
		)
	on btn1 pressed do (
		fsource = GetOpenFileName \
		caption:"Select a File" \
		types: "PCMESH (*.*)|*.pcmesh|PKG (*.*)|*.pkg|All files (*.*)|*.*|"
		if (fsource!=undefined) AND ((doesFileExist fsource)==true) then (
			f = fopen fsource "rb"
			fext = uppercase(getFilenameType fsource)
			case fext of (
				".PKG": (
					files = _file()
					num_folders = readlong f #unsigned
					num_files = readlong f #unsigned
					data_size = readlong f #unsigned
					for i = 1 to num_folders do ( -- folder names
						folder_name = (readstringfixed f 0x40)
						for x = 1 to (readlong f #unsigned) do ( -- files in folder
							file_index = readlong f #unsigned
							)
						)
					for i = 1 to num_files do ( -- file name's
						file_name = (readstringfixed f 0x28)
						file_size = readlong f #unsigned
						file_flag = readlong f #unsigned -- related to compression?
						append files.filename file_name
						append files.size file_size
						)
					for i = 1 to num_files do (
						fileName = ((getFilenamePath fsource) + "\\" + files.filename[i])
						close (createfile fileName)
						s = fopen fileName "wb"
						for x = 1 to files.size[i] do (
							writebyte s (readbyte f #unsigned) #unsigned
							)
						fclose s
						)
					format "Last Read @ 0x%\n" ((bit.intAsHex(ftell f))as string)
					fclose f
					messagebox "Completed!"
					)
				".PCMESH": (
					g = _geometry()
					delete $*
					filetype = readlong f #unsigned
					case filetype of (
						0x4D584350: (
							readlong f #unsigned
							readlong f #unsigned
							readlong f #unsigned -- first object offeset
							readlong f #unsigned -- ? 0
							vertex_count = readlong f #unsigned -- texture corrdinate count
							vertex_offset = readlong f #unsigned -- offsets to object
							tvertex_count = readlong f #unsigned -- vertex count
							tvertex_offset = readlong f #unsigned -- texture corrdinate offset
							face_count = readlong f #unsigned -- ?? bone count
							face_offset = readlong f #unsigned -- face offset 
							readlong f #unsigned
							readlong f #unsigned
							readlong f #unsigned
							readlong f #unsigned
							readlong f #unsigned
							ReadFixedString f 0x20
							readfloat f
							readfloat f
							readfloat f
							readfloat f
							readfloat f
							for i = 1 to 4 do ( -- min / max?
								([(readfloat f),(readfloat f),(readfloat f)]*(readfloat f))
								([(readfloat f),(readfloat f),(readfloat f)]*(readfloat f))
								)
							bone_count = readlong f #unsigned
							bone_offset = readlong f #unsigned
							element_count = readlong f #unsigned -- count, 1
							element_offset = readlong f #unsigned -- offsets to a small section after bones
							fseek f bone_offset #seek_set
							for i = 1 to bone_count do ( -- 64
								m = (matrix3 \
									([(readfloat f),(readfloat f),(readfloat f)]+(readfloat f)) \
									([(readfloat f),(readfloat f),(readfloat f)]+(readfloat f)) \
									([(readfloat f),(readfloat f),(readfloat f)]+(readfloat f)) \
									([(readfloat f),(readfloat f),(readfloat f)]*(readfloat f)*mscale)
									)
								rotateX m 90
				-- 				d = Dummy transform:
								d = bonesys.createbone m.row4 (m.row4+[0,1,0]) [1,0,0]
								d.transform = m
								d.showLinks = d.showLinksOnly = true
								append g.skeleton d
								)
							fseek f element_offset #seek_set
							readlong f #unsigned -- ?? material id
							readlong f #unsigned -- num faces in material?
							readlong f #unsigned -- offset?
							
							fseek f vertex_offset #seek_set
							for i = 1 to vertex_count do (
								vx = readfloat f
								vy = readfloat f
								vz = readfloat f
								nx = readfloat f
								ny = readfloat f
								nz = readfloat f
								b1 = readshort f + 1
								b2 = readshort f + 1
								b3 = readshort f + 1
								b4 = readshort f + 1
								w1 = readfloat f
								w2 = readfloat f
								w3 = readfloat f
								w4 = readfloat f
								append g.position (RH2LH [vx,vy,vz])
								append g.weight #(w1,w2,w3,w4)
								append g.boneid #(b1,b2,b3,b4)
								)
							fseek f tvertex_offset #seek_set
							for i = 1 to tvertex_count do (
								readlong f -- ff's
								tu = readfloat f
								tv = readfloat f
								readfloat f -- additional uv channels
								readfloat f
								readfloat f
								readfloat f
								append g.texture [tu,1-tv,0]
								)
							fseek f face_offset #seek_set
							triangle_strip(face_count)
							buildObj()
							)
						default: (
							format "File type [%] unsupported\n" filetype
							)
						)
					)
				default: (
					Messagebox ("File Type ["+fext+"] Not Supported")
					)
				)
			fclose f
			)
		else (
			Print "Aborted."
			)
		)
	on spn1 changed state do (
		mscale = state
		)
	)
createdialog pcmesh_importer